<template>
  <div>
    <div id="header">
      <div id="main-toolbar">
        <div class="toolbar-space" id="spacer-left">
          <div id="logo">CoT</div>
        </div>
        <div v-for="(value, key) in mainColours" :key="key">
          <button @click="shadeToolbarToggle(key)" :id="key"></button>
        </div>
      </div>
      <div id="shade-toolbar-id" class="shade-toolbar">
        <div class="shadeColour" id="shades">
          <button v-for="(shade, index) in shades" :key="index" :class="shade.name" @click="toggleShadeInfo(shade.name)"></button>
          <!-- <button class="shade-2" @click="toggleShadeInfo('shade-2')"></button>
          <button class="shade-3" @click="toggleShadeInfo('shade-3')"></button>
          <button class="shade-4" @click="toggleShadeInfo('shade-4')"></button>
          <button class="shade-5" @click="toggleShadeInfo('shade-5')"></button>
          <button class="shade-6" @click="toggleShadeInfo('shade-6')"></button>
          <button class="shade-7" @click="toggleShadeInfo('shade-7')"></button>
          <button class="shade-8" @click="toggleShadeInfo('shade-8')"></button>
          <button class="shade-9" @click="toggleShadeInfo('shade-9')"></button> -->
        </div>
      </div>
    </div>
    <div id="content">
      <div class="contentinfoleft"></div>
      <div id="info">
        <div class="link">
          <div v-for="(shade, index) in shades" :key="index" :class="shade.link + ' shadelinkhello'"></div>
          <!-- <div class="shadelink-2 shadelinkhello"></div>
          <div class="shadelink-3 shadelinkhello"></div>
          <div class="shadelink-4 shadelinkhello"></div>
          <div class="shadelink-5 shadelinkhello"></div>
          <div class="shadelink-6 shadelinkhello"></div>
          <div class="shadelink-7 shadelinkhello"></div>
          <div class="shadelink-8 shadelinkhello"></div>
          <div class="shadelink-9 shadelinkhello"></div> -->
        </div>
        <div class="main"></div>
      </div>
      <div class="contentinforight"></div>
      <div id="footer"></div>
    </div>
  </div>
</template>

<script>
import shades from "~/components/shades.vue"

export default {
  data () {
    return {
      mainColours: {
        red: 0,
        redorange: 18,
        orange: 36,
        yellow: 54,
        yellowgreen: 72,
        lightgreen: 90,
        green: 135,
        greencyan: 162,
        cyan: 180,
        lightblue: 198,
        blue: 216,
        bluepurple: 234,
        darkpurple: 252,
        purple: 270,
        darkpink: 288,
        pink: 306,
        pinkred: 324,
      },
      shades: [
        {name: 'shade-1', link: 'shadelink-1', lightness: '10%'},
        {name: 'shade-2', link: 'shadelink-2', lightness: '20%'},
        {name: 'shade-3', link: 'shadelink-3', lightness: '30%'},
        {name: 'shade-4', link: 'shadelink-4', lightness: '40%'},
        {name: 'shade-5', link: 'shadelink-5', lightness: '50%'},
        {name: 'shade-6', link: 'shadelink-6', lightness: '60%'},
        {name: 'shade-7', link: 'shadelink-7', lightness: '70%'},
        {name: 'shade-8', link: 'shadelink-8', lightness: '80%'},
        {name: 'shade-9', link: 'shadelink-9', lightness: '90%'},
      ],
      currentColour: '',
      shadesVisible: false,
      selectedShade: '',
    }
  },
  components: {
    shades
  },
  methods: {
    shadeToolbarToggle(colour) {
      var self = this
      var timeout = 0
      if(this.selectedShade!==''){
        document.querySelector('.'+this.selectedShade.replace('shade', 'shadelink')).style.setProperty('max-height', '0px')
        document.querySelector('.'+this.selectedShade).style.removeProperty('opacity')
        document.querySelector('button').style.setProperty('opacity', '1')
        timeout = 500
        this.selectedShade=''
      }
      setTimeout(function(){
        var colours = self.mainColours
        if (self.currentColour === colour){
          document.getElementById('shade-toolbar-id').className ='shade-toolbar'
          self.currentColour = ''
          self.shadesVisible = false
        } else {
          self.currentColour = colour
          if (self.shadesVisible === false) {
            for (var shade in self.shades) {
              console.log(document.querySelector('.'+self.shades[shade].link))
              document.querySelector('.'+self.shades[shade].name).style.setProperty('background-color', 'hsl('+colours[colour]+', 100%, '+self.shades[shade].lightness+')')
              document.querySelector('.'+self.shades[shade].link).style.setProperty('background-color', 'hsl('+colours[colour]+', 100%, '+self.shades[shade].lightness+')')
            }
            document.getElementById('shade-toolbar-id').className ='shade-toolbar-hello'
          } else {
            document.getElementById('shade-toolbar-id').className ='shade-toolbar'
            setTimeout(function(){
              for (var shade in self.shades) {
              document.querySelector('.'+self.shades[shade].name).style.setProperty('background-color', 'hsl('+colours[colour]+', 100%, '+self.shades[shade].lightness+')')
              document.querySelector('.'+self.shades[shade].link).style.setProperty('background-color', 'hsl('+colours[colour]+', 100%, '+self.shades[shade].lightness+')')
            }
              document.getElementById('shade-toolbar-id').className ='shade-toolbar-hello'
            }, timeout)
          }
          self.shadesVisible = true
        }
      }, 200)
    },
    toggleShadeInfo(shadeNumber){
      var colours = this.mainColours
      var currentColour = this.currentColour
      if (this.selectedShade === shadeNumber){
        document.querySelector('.'+shadeNumber.replace('shade', 'shadelink')).style.setProperty('max-height', '0px')
        document.querySelector('.'+shadeNumber+':hover').style.removeProperty('opacity', '0.7')
        this.selectedShade = ''
      } else {
        if (this.selectedShade !== ''){
          document.querySelector('.'+this.selectedShade.replace('shade', 'shadelink')).style.setProperty('max-height', '0px')
          document.querySelector('.'+this.selectedShade).style.removeProperty('opacity')
        }
        document.querySelector('.'+shadeNumber+':hover').style.setProperty('opacity', '1')
        document.querySelector('.'+shadeNumber.replace('shade', 'shadelink')).style.setProperty('max-height', '30px')
        this.selectedShade = shadeNumber
        setTimeout(function (){
          document.querySelector('.main').style.setProperty('background-color', 'hsl('+colours[currentColour]+', 100%, '+shadeNumber.replace('shade-', '')+'0%)')
          document.querySelector('.main').style.setProperty('max-height', '1000px')
        }, 300)
      }
    }
  }
}
</script>

<style>
@font-face {
  font-family: titleFont;
  src: url(~/assets/fonts/RalewayDots-Regular.ttf);
}
:root {
  --background-color: 20;
}
body {
  margin:0;
}
#header {
  display: grid;
  min-height: 100%;
  grid-template-rows: 60px 60px;
  grid-template-areas:  "main-toolbar"
                        "shade-toolbar";
}
.toolbar-space {
  background-color: rgb(247, 247, 247);
}
#logo {
  padding-left: 10px;
  padding-top: 5px;
  justify-content: center;
  align-items: center;
  text-align: center;
  font-family: titleFont;
  font-size: 40px;
  grid-area: logo;
  height: 40px;
  width: 80px;
}
button {
  opacity: 1;
  border: 0;
  padding: 0 0 0 0;
}
button:hover {
  opacity: 0.7;
  cursor: pointer;
}
button:focus {
  outline: none;
}
#red {
  grid-area: red;
  background-color: hsl(0, 100%, 50%);
  height: 60px;
  width: 60px;
}
#redorange {
  grid-area: redorange;
  background-color: hsl(18, 100%, 50%);
  height: 60px;
  width: 60px;
}
#orange {
  grid-area: orange;
  background-color: hsl(36, 100%, 50%);
  height: 60px;
  width: 60px;
}
#yellow {
  grid-area: yellow;
  background-color: hsl(54, 100%, 50%);
  height: 60px;
  width: 60px;
}
#yellowgreen {
  grid-area: yellowgreen;
  background-color: hsl(72, 100%, 50%);
  height: 60px;
  width: 60px;
}
#lightgreen {
  grid-area: lightgreen;
  background-color: hsl(90, 100%, 50%);
  height: 60px;
  width: 60px;
}
#green {
  grid-area: green;
  background-color: hsl(135, 100%, 50%);
  height: 60px;
  width: 60px;
}
#greencyan {
  grid-area: greencyan;
  background-color: hsl(162, 100%, 50%);
  height: 60px;
  width: 60px;
}
#cyan {
  grid-area: cyan;
  background-color: hsl(180, 100%, 50%);
  height: 60px;
  width: 60px;
}
#lightblue {
  grid-area: lightblue;
  background-color: hsl(198, 100%, 50%);
  height: 60px;
  width: 60px;
}
#blue {
  grid-area: blue;
  background-color: hsl(216, 100%, 50%);
  height: 60px;
  width: 60px;
}
#bluepurple {
  grid-area: bluepurple;
  background-color: hsl(234, 100%, 50%);
  height: 60px;
  width: 60px;
}
#darkpurple {
  grid-area: darkpurple;
  background-color: hsl(252, 100%, 50%);
  height: 60px;
  width: 60px;
}
#purple {
  grid-area: purple;
  background-color: hsl(270, 100%, 50%);
  height: 60px;
  width: 60px;
}
#darkpink {
  grid-area: darkpink;
  background-color: hsl(288, 100%, 50%);
  height: 60px;
  width: 60px;
}
#pink {
  grid-area: pink;
  background-color: hsl(306, 100%, 50%);
  height: 60px;
  width: 60px;
}
#pinkred {
  grid-area: pinkred;
  background-color: hsl(324, 100%, 50%);
  height: 60px;
  width: 60px;
}
.shade-1 {
  grid-area: shade-1;
  width: 60px;
  height: 100%;
  border-bottom-left-radius: 12px;
}
.shade-2 {
  grid-area: shade-2;
  width: 60px;
  height: 100%;
}
.shade-3 {
  grid-area: shade-3;
  width: 60px;
  height: 100%;
}
.shade-4 {
  grid-area: shade-4;
  width: 60px;
  height: 100%;
}
.shade-5 {
  grid-area: shade-5;
  width: 60px;
  height: 100%;
}
.shade-6 {
  grid-area: shade-6;
  width: 60px;
  height: 100%;
}
.shade-7 {
  grid-area: shade-7;
  width: 60px;
  height: 100%;
}
.shade-8 {
  grid-area: shade-8;
  width: 60px;
  height: 100%;
}
.shade-9 {
  grid-area: shade-9;
  width: 60px;
  height: 100%;
  border-bottom-right-radius: 12px;
}
.shadelink-1 {
  grid-area: shadelink-1;
  width: 50px;
}
.shadelink-2 {
  grid-area: shadelink-2;
  width: 60px;
}
.shadelink-3 {
  grid-area: shadelink-3;
  width: 60px;
}
.shadelink-4 {
  grid-area: shadelink-4;
  width: 60px;
}
.shadelink-5 {
  grid-area: shadelink-5;
  width: 60px;
}
.shadelink-6 {
  grid-area: shadelink-6;
  width: 60px;
}
.shadelink-7 {
  grid-area: shadelink-7;
  width: 60px;
}
.shadelink-8 {
  grid-area: shadelink-8;
  width: 60px;
}
.shadelink-9 {
  grid-area: shadelink-9;
  width: 50px;
}
#main-toolbar {
  display: grid;
  grid-area: main-toolbar;
  grid-template-rows: 60px;
  grid-template-columns: 1fr 60px 60px 60px 60px 60px 60px 60px 60px 60px 60px 60px 60px 60px 60px 60px 60px 60px;
  grid-template-areas: "spacer-left red redorange orange yellow yellowgreen lightgreen green greencyan cyan lightblue blue bluepurple darkpurple purple darkpink pink pinkred";
  height: 60px;
  box-shadow: 0 8px 16px 0 rgba(0,0,0,0.2), 0 6px 20px 0 rgba(0,0,0,0.19);
  z-index: 1;
}
.shade-toolbar {
  grid-area: shade-toolbar;
  display: grid;
  grid-template-rows: 1fr;
  width: 100%;
  grid-template-columns: 1fr auto 1fr;
  grid-template-areas: "shade-toolbar-space-left shades shade-toolbar-space-right";
  max-height: 0px;
  -webkit-transition: .5s cubic-bezier(0, 1, 0.5, 1);
  -moz-transition: .5s cubic-bezier(0, 1, 0.5, 1);
  -o-transition: .5s cubic-bezier(0, 1, 0.5, 1);
  transition: .5s cubic-bezier(0, 1, 0.5, 1);
}
.shade-toolbar-hello {
	grid-area: shade-toolbar;
  display: grid;
  grid-template-rows: 1fr;
  width: 100%;
  grid-template-columns: 1fr auto 1fr;
  grid-template-areas: "shade-toolbar-space-left shades shade-toolbar-space-right";
  max-height: 60px;
  -webkit-transition: .5s cubic-bezier(0, 1, 0.5, 1);
  -moz-transition: .5s cubic-bezier(0, 1, 0.5, 1);
  -o-transition: .5s cubic-bezier(0, 1, 0.5, 1);
  transition: .5s cubic-bezier(0, 1, 0.5, 1);
}
#shades {
  grid-area: shades;
  display: grid;
  grid-template-rows: 1fr;
  grid-template-columns: 60px 60px 60px 60px 60px 60px 60px 60px 60px;
  grid-template-areas: "shade-1 shade-2 shade-3 shade-4 shade-5 shade-6 shade-7 shade-8 shade-9";
  border-bottom-left-radius: 12px;
  border-bottom-right-radius: 12px;
}
#content {
  display: grid;
  grid-template-columns:  1fr 90% 1fr;
  grid-template-rows: 700px 10px;
  grid-template-areas:  "contentinfoleft content contentinforight"
                        "footerinfoleft footer footerinforight";
}
#info {
  display: grid;
  grid-template-rows: 30px 1fr;
  grid-template-areas:  "link"
                        "main";
  height: 100%;
  width: 100%;
}
.link {
  grid-area: link;
  display: grid;
  grid-template-rows: 1fr;
  grid-template-columns: 1fr 50px 60px 60px 60px 60px 60px 60px 60px 50px 1fr;
  grid-template-areas: "leftlinkspace shadelink-1 shadelink-2 shadelink-3 shadelink-4 shadelink-5 shadelink-6 shadelink-7 shadelink-8 shadelink-9 rightlinkspace";
}
.shadelinkhello {
  max-height: 0px;
  -webkit-transition: .5s cubic-bezier(0, 1, 0.5, 1);
  -moz-transition: .5s cubic-bezier(0, 1, 0.5, 1);
  -o-transition: .5s cubic-bezier(0, 1, 0.5, 1);
  transition: .5s cubic-bezier(0, 1, 0.5, 1);
}
.main {
  width: 100%;
  background-color: white;
  max-height: 0px;
  -webkit-transition: 3s cubic-bezier(0, 1, 0.5, 1);
  -moz-transition: 3s cubic-bezier(0, 1, 0.5, 1);
  -o-transition: 3s cubic-bezier(0, 1, 0.5, 1);
  transition: 3s cubic-bezier(0, 1, 0.5, 1);
}
#contentinfoleft {
  grid-area: contentinfoleft
}
#contentinforight {
  grid-area: contentinforight
}
</style>
